<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>mmWave API</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
<link href="tabs.css" rel="stylesheet" type="text/css">
</head><body>
<table width=100%>
<tr>
  <td bgcolor="black" width="1"><a href="http://www.ti.com"><img border=0 src="../../tilogo.gif"></a></td>
  <td bgcolor="red"><img src="../../titagline.gif"></td>
</tr>
</table>
<!-- Generated by Doxygen 1.8.11 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li class="current"><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">mmWave API </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>The mmWave API allow application developers to be abstracted from the lower layer drivers and the mmWave link API.</p>
<p>The mmWave file should be included in an application as follows:</p>
<div class="fragment"><div class="line"><span class="preprocessor">#include &lt;<a class="code" href="mmwave_8h.html">ti/control/mmwave/mmwave.h</a>&gt;</span></div></div><!-- fragment --><h2>Initializing the module</h2>
<p>The mmWave module is initialized by using the <a class="el" href="group___m_m_w_a_v_e___c_t_r_l___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gac59ad4bf4bd9044776dcbf7c000105a0">MMWave_init</a> API The module can execute in either of the following domains:</p><ul>
<li>XWR14xx: The module executes on the MSS</li>
<li>XWR16xx: The module executes on both the MSS and DSS</li>
</ul>
<h2>Synchronizing the module</h2>
<p>Once the module has been initialized it has to be synchronized before it can be used. This is done using the <a class="el" href="group___m_m_w_a_v_e___c_t_r_l___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga11b05c9151ca387dc52dc6bec1a0d6e0">MMWave_sync</a> API. This is required because on the XWR16xx the module can execute on both the DSS and MSS. We need to ensure that the modules on each domain are operational before they can be used.</p>
<p>On the XWR14xx; the synchronization is not really required but in order to maintain the same API behavior between XWR14xx and XWR16xx the API needs to be invoked.</p>
<h2>Opening the module</h2>
<p>After the mmWave module has been synchronized; the mmWave module needs to be opened. This will initialize the mmWave link to the BSS. While operating in minimal mode applications can invoke the mmWave link API directly after this step has been initiated.</p>
<p>In cooperative mode; only one of the domains should be deemed responsible for opening the mmWave module.</p>
<h2>Configuration of the module</h2>
<p>Applications are responsible for populate and configuring the BSS using the configuration <a class="el" href="group___m_m_w_a_v_e___c_t_r_l___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga58b9f2692b9395a84c3649b29f90ba36">MMWave_config</a> API. The API will take the application supplied configuration and will pass this to the BSS via the mmWave link API(s). Application developers are abstracted from the calling sequence and the various synchronization events which are required.</p>
<p>Once the configuration has been completed; the application can setup the data path. After the data path has been successfully configured application developers can start the mmWave.</p>
<p>The mmWave module can be configured by multiple domains but the applications should ensure that the configuration done by a domain be completed before the other domain initiates the configuration. Failure to do so will result in unpredictable behavior.</p>
<h2>Starting the mmWave</h2>
<p>After successful configuration the mmWave needs to be started using the <a class="el" href="group___m_m_w_a_v_e___c_t_r_l___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gae72b02f34545d64f7f142d8bf72addee">MMWave_start</a> API. On successful execution of the API the data path is being excercised.</p>
<h2>Executing the mmWave module</h2>
<p>The mmWave module requires an execution context which needs to be provided by the application. This is because there are asynchronous events and response messages which are received by the BSS using the mmWave Link infrastructure. Thes need to be handled and processed in the application supplied execution context.</p>
<p>Failure to provide and execution context and not invoking the <a class="el" href="group___m_m_w_a_v_e___c_t_r_l___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gaa574a4299227f0e4a07469b8e69fc645">MMWave_execute</a> API can result in the mmWave API getting stuck and the application loosing synchronization with the other domains in the system.</p>
<h2>Callback functions</h2>
<p>While working in the cooperative mode the mmWave is executing on both the MSS and DSS. Each domain registers a callback function which is invoked by the mmWave module if the peer domain does an equivalent operation.</p>
<p>For example:- The table below illustrates an example flow of the mmWave API and the invocation of the callback function in the peer domain</p>
<table class="doxtable">
<tr>
<th>MSS </th><th>DSS  </th></tr>
<tr>
<td>MMWave_open(&amp;openCfg) </td><td>openFxn (ptrOpenCfg) </td></tr>
<tr>
<td>cfgFxn (ptrControlCfg) </td><td>MMWave_config (&amp;ctrlCfg) </td></tr>
<tr>
<td>MMWave_start (&amp;startCfg) </td><td>startFxn (ptrStartCfg) </td></tr>
<tr>
<td>MMWave_stop () </td><td>stopFxn () </td></tr>
<tr>
<td>MMWave_close () </td><td>closeFxn () </td></tr>
</table>
<p>Callback functions allow an application to be notified when an action has been taken. Along with this the equivalent parameters are also passed to the peer domain. This allows both the domains to remain synchronized</p>
<h2>Error Code</h2>
<p>The mmWave API return an encoded error code. The encoded error code has the following information:-</p><ul>
<li>Error or Informational message</li>
<li>mmWave error code</li>
<li>Subsystem error code The mmWave module is a high level control module which is basically layered over multiple modules like the mmWave Link, Mailbox etc. When an mmWave API reports a failure it could be because of a multitude of reasons. Also the mmWave Link API reports certains errors as not fatal but informational. In order to satisfy these requirements the error code returned by the mmWave API is encoded. There exists a <a class="el" href="group___m_m_w_a_v_e___c_t_r_l___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gab01615f3c8764a3e638a6d5261733e55">MMWave_decodeError</a> which can be used to determine the exact error code and error level. </li>
</ul>
</div></div><!-- contents -->
<hr size="1"><small>
Copyright  2018, Texas Instruments Incorporated</small>
</body>
</html>
